TRAININGGROUNDS_Buff_Enemy_ProvingGrounds_Defend = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Buff)

function TRAININGGROUNDS_Buff_Enemy_ProvingGrounds_Defend:setCustomBuffInfo(combat)
	TRAININGGROUNDS_Buff.setCustomBuffInfo(self,combat)
	--self.duration=3000
	self.duration=10000	
	self.icon="Interface\\Icons\\ability_warrior_shieldreflection"
	self.shield=nil
end

function TRAININGGROUNDS_Buff_Enemy_ProvingGrounds_Defend:OnBuffStart()
	TRAININGGROUNDS_Buff.OnBuffStart(self)
	
	local shield=TRAININGGROUNDS_Particle_IllusionaryGuardianShield.new()
	shield:setup(self.combat.character.environment)
	shield.character=self.combat.character
	local angle=self.combat.character.currentfacing-math.pi/2
	-- distance of 1+ is mandatory for proper ysorting
	-- WoW appears to use negative distance!
	local distance=1
	shield.x=self.combat.character.x+math.cos(angle)*distance
	shield.y=self.combat.character.y+math.sin(angle)*distance
	shield:SetAdjustedFacing(self.combat.character.currentfacing)
	
	self.shield=shield
end

-- function TRAININGGROUNDS_Buff_Enemy_ProvingGrounds_Defend:OnOwnerDie(damagetime)	

-- end

function TRAININGGROUNDS_Buff_Enemy_ProvingGrounds_Defend:OnBuffEnd(endtime)	
	TRAININGGROUNDS_Buff.OnBuffEnd(self,endtime)
	
	self.shield.expirytime=endtime+500

end