TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.TIGERPALMCOST=50
--TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.TIGERPALMCOST=40
TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.COMBOBREAKERCHANCE=0.08
--TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.COMBOBREAKERCHANCE=0.50

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Tiger Palm"
	self.shortspellname="TP"
	
	self.requirefacing=true
	
	--self.animationlength=1000
	--self.animationsequence=670	
	self.animationname="TigerPalm"
	self.impacttime=500

			
	self.resource=combat.energy
	self.resourcecost=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.TIGERPALMCOST	
	
	self.icon="Interface\\Icons\\ability_monk_tigerpalm"
	
	self.damage=70*1.15		-- rank 3 trait
	
	self.procscombostrikes=true
	
end



--function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm:ApplyExecutedSpellSideEffects(executespelltick)
function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm:OnImpact(executespelltick)
	TRAININGGROUNDS_Spell.OnImpact(self,executespelltick)

	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,executespelltick)
	
	self.combat:SetSCKTarget(self.target,executespelltick+15000)
	
	self.combat.chi:AddToValue(2)
	--power strikes check
	local ps=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_PowerStrikes)
	if(ps~=nil)then
		if(self.combat.chi.value<self.combat.chi.max)then
			self.combat.chi:AddToValue(1)
			ps.stacks=ps.stacks-1
			if(ps.stacks<=0)then
				ps:SelfDispel()
			end
		end
	end
	
	--EotT check
	local eottcontroller=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_EyeOfTheTigerController)
	if(eottcontroller~=nil)then
		if(eottcontroller.eott~=nil)then
			eottcontroller.eott:SelfDispel()
		end
		eottcontroller.eott=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_EyeOfTheTiger.new()
		eottcontroller.eott:setup(self.combat,executespelltick)
		eottcontroller.eott.target=self.target
		eottcontroller.eott:CalculateDurationAndTickTime()		
	end	
	
	if(self.combat.blackoutkick~=nil)then
		if(math.random()<TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigerPalm.COMBOBREAKERCHANCE) then
			local buff
			buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ComboBreakerBlackoutKick.new()
			buff:setup(self.combat,executespelltick)
		end
	end
end
