TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TornadoKick = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TornadoKick:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)	
	
	self.spellname="Tornado Kick"
	self.shortspellname="BoK (TK)"
		
	self.requirefacing=true
		
	self.animationsequence=662
	self.animationlength=1000
	
	self.resource=combat.chi
	self.resourcecost=1
	
	self.damage=246 -- 6.2 PTR
	
	self.icon="Interface\\Icons\\ability_monk_hurricanestrike"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TornadoKick:haveResources()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ComboBreakerBlackoutKick)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	elseif(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	return TRAININGGROUNDS_Spell.haveResources(self)	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TornadoKick:deductResourceCost()
	local blackoutkick=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ComboBreakerBlackoutKick)
	if(blackoutkick~=nil)then
		blackoutkick:SelfDispel()
	elseif(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return
	else
		TRAININGGROUNDS_Spell.deductResourceCost(self)
	end
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TornadoKick:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)

	self.combat.blackoutkick.istornado=false
	self.button.frame:Hide()
	self.combat.blackoutkick.button.frame:Show()
	
end