-- A "gamepad" style key intended for arcade gameplay.
-- For spells, use Game\Spells\SpellButton instead.

TRAININGGROUNDS_Key = {}
TRAININGGROUNDS_Key.__index = TRAININGGROUNDS_Key

function TRAININGGROUNDS_Key:new()
	local self={}
	setmetatable(self, TRAININGGROUNDS_Key)	
	
	self.current=false;		-- whether key is currently down
	self.pressed=false;		-- true when OnKeyDown
	self.released=false;	-- true when OnKeyUp
		-- (WoW is nice enough not to trigger repeat events when the key is held down)
	
	return self
end

function TRAININGGROUNDS_Key:SetKey(state)
	self.current=state
	if(state==true)then
		self.pressed=true
	else
		self.released=true
	end
end



