--TODO: we started using texcoords instead of scrollframes
-- -- rename this class
TRAININGGROUNDS_StylizedScrollframeIntroObject = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_GameObject)

TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_WAIT=1
TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_SCROLL=2
TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_FULLTITLE=3
TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_DONE=4

function TRAININGGROUNDS_StylizedScrollframeIntroObject:SetFrame()
	self.frame=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.scrollframes={}
	self.slices=9
	self.slicewidth=8		
	for i=1,self.slices,1 do
		--local f=TRAININGGROUNDS_ReusableScrollFrames.getFrame() --!!!
		local f=TRAININGGROUNDS_ReusableFrames.getFrame()
		self.scrollframes[i]=f				--	<--- POSSIBLE CRASH ERROR
	end
	self.fulltitleframe=TRAININGGROUNDS_ReusableFrames.getFrame()
	

	self.scrollprogress=0
	self.fulltitleprogress=0
	self.defaultscrollticktimer=0.016
	--self.defaultscrollticktimer=0.032
	--self.defaultscrollticktimer=0.064
	--self.defaultscrollticktimer=0.1
	self.scrollticktimer=self.defaultscrollticktimer
	
	self.status=TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_WAIT
	
end

function TRAININGGROUNDS_StylizedScrollframeIntroObject:SetAppearance()
	self.frame:SetWidth(16)
	self.frame:SetHeight(16)
	self.frame.parent=self.environment.frame
	self.frame:SetParent(self.frame.parent)
	self.frame:SetPoint("CENTER",self.frame.parent,"CENTER",0,0)
	self.frame:Show()
	for i=1,#self.scrollframes,1 do
		local f=self.scrollframes[i]
		--f.scrollframe:SetWidth(512)
		
		-- -- TODO: add self.scrollprogress to sethorizontalscroll and setpoint
		-- f.scrollframe:SetWidth(self.slicewidth)
		-- f.scrollframe:SetHorizontalScroll(i*self.slicewidth)
		-- f.scrollframe:SetHeight(512*(45/512.0))		
		-- f.scrollframe:SetFrameLevel(255)
		-- f.scrollframe.parent=self.frame
		-- f.scrollframe:SetParent(f.scrollframe.parent)
		-- f.scrollframe:SetPoint("CENTER",f.scrollframe.parent,"CENTER",i*self.slicewidth,0)	
		-- f.scrollframe:Show()
		-- local a=1-math.abs(self.slices/2+.5-i)/(self.slices/2+.5)
		-- a=a*a
		-- f.scrollframe:SetAlpha(a)
		-- f:SetWidth(512)
		-- f:SetHeight(512*(45/512.0))
		-- f:SetPoint("CENTER",0,"CENTER",0,0)
		-- f:Show()	
		-- f.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\placeholder_logo.tga")
		-- -- --left, right, top, bottom
		-- f.texture:SetTexCoord(0,1,0,(45/512.0))	
		-- f.texture:Show()		
		
		local x=i*self.slicewidth
		local a=1-math.abs(self.slices/2+.5-i)/(self.slices/2+.5)
		a=a*a
		f.parent=self.frame
		f:SetParent(f.parent)
		f:SetAlpha(a)
		f:SetWidth(self.slicewidth)
		f:SetHeight(512*(121/1024.0))
		f:SetPoint("CENTER",f.parent,"CENTER",x,0)
		--f:Show()			

		f.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\placeholder_logo.tga")
		-- --left, right, top, bottom
		f.texture:SetTexCoord((x/512.0),((x+self.slicewidth)/512.0),0,(121/1024.0))	
		f.texture:Show()
		
		-- if(i==1)then
			-- TRAININGGROUNDS_FrameVisibilityCheck(f.scrollframe)
		-- end
	end
	self.fulltitleframe:SetWidth(512)
	self.fulltitleframe:SetHeight(512*(121/1024.0))		
	self.fulltitleframe:SetFrameLevel(255)
	self.fulltitleframe.parent=self.frame
	self.fulltitleframe:SetParent(self.fulltitleframe.parent)
	self.fulltitleframe:SetPoint("CENTER",self.fulltitleframe.parent,"CENTER",0,0)		
	self.fulltitleframe.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\placeholder_logo.tga")
	-- --left, right, top, bottom
	self.fulltitleframe.texture:SetTexCoord(0,1,0,(121/1024.0))	
	self.fulltitleframe.texture:Show()	
end

function TRAININGGROUNDS_StylizedScrollframeIntroObject:step(elapsed)
	self.scrollticktimer=self.scrollticktimer-elapsed
	while(self.scrollticktimer<0)do
		self.scrollticktimer=self.scrollticktimer+self.defaultscrollticktimer
		self.scrollprogress=self.scrollprogress+self.slicewidth
		self.fulltitleprogress=self.fulltitleprogress+1
		if(self.scrollticktimer<-1)then
			self.scrollticktimer=-1
		end
	end
	
	if(self.status==TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_WAIT)then
		--print(self.fulltitleprogress)
		--if(self.fulltitleprogress>16)then		
		if(self.fulltitleprogress>48)then
			self.scrollprogress=-self.slicewidth*self.slices
			self.status=TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_SCROLL
			-- for i=1,#self.scrollframes,1 do
				-- self.scrollframes[i]:Show()				
			-- end			
		end
	elseif(self.status==TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_SCROLL)then
		--print(self.scrollprogress)
		for i=1,#self.scrollframes,1 do
			local f=self.scrollframes[i]
			--f.scrollframe:SetHorizontalScroll(i*self.slicewidth+self.scrollprogress)
			local x=i*self.slicewidth+self.scrollprogress
			if(x<0 or x+self.slicewidth>512) then
				f:Hide()
			else
				f:Show()
			end
			f.texture:SetTexCoord(x/512.0,(x+self.slicewidth)/512.0,0,(121/1024.0))
			-- if(i==1) then
				-- print((x+self.slicewidth)/512.0)
			-- end
		end		
		--TODO: actual math based on SCREENWIDTH
		self.x=64+self.scrollprogress
		
		--if(self.scrollprogress>600) then self.scrollprogress=-16*12 end	--!!!
		if(self.scrollprogress>550) then
			--TODO: actual math based on SCREENWIDTH
			self.x=64+256
			for i=1,#self.scrollframes,1 do
				self.scrollframes[i]:Hide()
			end
			self.fulltitleframe:SetAlpha(0)
			self.fulltitleframe:Show()			
			self.fulltitleprogress=0
			self.status=TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_FULLTITLE			
		end
	elseif(self.status==TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_FULLTITLE)then
		local fadeinsteps=32.0
		--print(self.fulltitleprogress)
		--self.fulltitleframe:SetAlpha((self.fulltitleprogress*self.fulltitleprogress)/fadeinsteps)
		self.fulltitleframe:SetAlpha((self.fulltitleprogress)/fadeinsteps)
		if(self.fulltitleprogress>=fadeinsteps)then
			self.frame:SetAlpha(1)
			self.status=TRAININGGROUNDS_StylizedScrollframeIntroObject.STATUS_DONE
		end		
	end
end

function TRAININGGROUNDS_StylizedScrollframeIntroObject:Cleanup()
	TRAININGGROUNDS_GameObject.Cleanup(self)
	
	for i=1,#self.scrollframes,1 do
		--TRAININGGROUNDS_ReusableScrollFrames.removeFrame(self.scrollframes[i])		
		TRAININGGROUNDS_ReusableFrames.removeFrame(self.scrollframes[i])		
	end
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.fulltitleframe)
	
end