TRAININGGROUNDS_TemporaryParticleFrame = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_GameObject)

-- When creating a textbox, you'll need to call setup() to create the text frame,
-- then call SetText on the created frame,
-- then call draw() again to refresh the frame before the screen is drawn.

function TRAININGGROUNDS_TemporaryParticleFrame:SetFrame()
	--don't call super

	self.frame=TRAININGGROUNDS_ReusableFrames.getFrame()	
	self.frame.tag="TemporaryParticleFrame"	
	--TODO: set frame level	
	--self.frame:SetParent(self.parentframe) ----we are already setting frame's parent in super
	self.frame:SetWidth(200);self.frame:SetHeight(100)	
	self.particlewidth=200
	self.particleheight=100
end

-- function TRAININGGROUNDS_TemporaryParticleFrame:SetAppearance()
	-- --self.frame:Show()	
	-- self.frame:SetFrameLevel(255) --!!!
	-- --print("TRAININGGROUNDS_TemporaryParticleFrame:SetAppearance()")
-- end

function TRAININGGROUNDS_TemporaryParticleFrame:SetFrameSize()
	local camera=self.environment.camera
	self.frame:SetWidth(self.particlewidth*camera.zoom)
	self.frame:SetHeight(self.particleheight*camera.zoom)
end


function TRAININGGROUNDS_TemporaryParticleFrame:step(elapsed)
	local currenttime=self.environment.currenttime

	--print("TemporaryTextField.step "..elapsed.." "..currenttime)

	TRAININGGROUNDS_GameObject.step(self,elapsed,currenttime)
	
	
	
	
	if(self.expirytime~=nil)then
		local alpha=(self.expirytime-currenttime)/1000.0
		if(alpha>1)then alpha=1 end	
		self.frame:SetAlpha(alpha)
	end
end


function TRAININGGROUNDS_TemporaryParticleFrame:OnLandOnGround()
	self.z=math.abs(self.z)
	self.zspeed=math.abs(self.zspeed)/2
end

function TRAININGGROUNDS_TemporaryParticleFrame:BelowGround()
	--TODO: call super?	
	self.z=0
	self.zspeed=0
end

