TRAININGGROUNDS_FakePlayerCharacter_DeathKnight = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_DeathKnight:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)
	self:ApplyDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_DeathKnight:SetEquipmentInfo()
	self.equipment=TRAININGGROUNDS_Equipment.new()
	--self.equipment:EquipItemToKnownSlot(119469,"MainHandSlot")
	self.equipment:EquipItemToKnownSlot(119470,"ChestSlot")
	self.equipment:EquipItemToKnownSlot(119471,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(119472,"HandsSlot")
	self.equipment:EquipItemToKnownSlot(119473,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(119474,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(119475,"ShoulderSlot")
	self.equipment:EquipItemToKnownSlot(119476,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(119477,"WristSlot")
	self.equipment:EquipItemToKnownSlot(119478,"MainHandSlot")
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		self.equipment:EquipItemToKnownSlot(119478,"SecondaryHandSlot")
	else
		self.equipment:EquipItemToKnownSlot(29271,"SecondaryHandSlot")
	end
	self.equipment:EquipItemToKnownSlot(119479,"BackSlot")
	
	--for i=119470,119477,1 do
		--self.equipment:TryItem(i)	
	--end
end

function TRAININGGROUNDS_FakePlayerCharacter_DeathKnight:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.OneHandBasicAttack,
		FakePlayerCharacterTitleAnimations.OneHandFancyAttack		
	}
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldFancyAttack)
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldSlashCombo)
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldStabCombo)
		tinsert(sequences,FakePlayerCharacterTitleAnimations.TankBlock)
	end
	return sequences
end