TRAININGGROUNDS_Buff_W7_WindwalkerMonk_PowerStrikesController = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Buff)

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_PowerStrikesController:setCustomBuffInfo(combat,executiontime)
	TRAININGGROUNDS_Buff.setCustomBuffInfo(self,combat,executiontime)
	self.duration=nil	
	self.visibletoplayer=false

	self.tickfrequency=15000
	--self.tickfrequency=4000  --!!!
	self.tickonbuffstart=false	
	
	self.powerstrikesbuff=nil
end

function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_PowerStrikesController:step(elapsed,currenttime)
	TRAININGGROUNDS_Buff.step(self,elapsed,currenttime)
	
	if(self.powerstrikesbuff~=nil)then
		if(self.powerstrikesbuff.dead==true)then
			self.powerstrikesbuff=nil
		end		
	end
	
	-- stop "recharging" once we hit 2 stacks
	if(self.powerstrikesbuff~=nil)then
		if(self.powerstrikesbuff.stacks>=2)then
			self.nextticktime=currenttime+self.tickfrequency
		end
	end
end



function TRAININGGROUNDS_Buff_W7_WindwalkerMonk_PowerStrikesController:OnBuffTick(ticktime)
	TRAININGGROUNDS_Buff.OnBuffTick(self,ticktime)
	
	local ps=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_PowerStrikes.new()
	ps:setup(self.combat,ticktime)
	--at this point we don't know if the current buff is the one we just made, or an existing one, so check for it	
	self.powerstrikesbuff=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_PowerStrikes)
	
end
