TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)	
	
	self.spellname="Blackout Kick"
	self.shortspellname="BoK"
	
	self.requirefacing=true
		
	-- self.animationsequence=662
	-- self.animationlength=1000
	self.animationname="BlackoutKick"
	
	self.resource=combat.chi
	self.resourcecost=1
	
	self.impacttime=300
	self.damage=325*1.15 	-- trait
	
	self.istornado=false
	
	self.procscombostrikes=true
	
	self.icon="Interface\\Icons\\ability_monk_roundhousekick"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick:haveResources()
	if(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ComboBreakerBlackoutKick)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	elseif(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return TRAININGGROUNDS_SpellSuccessOrFailureResult_quicknew(true,nil)
	end
	return TRAININGGROUNDS_Spell.haveResources(self)
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick:deductResourceCost()
	--print("deductResourceCost")
	local blackoutkick=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ComboBreakerBlackoutKick)
	if(blackoutkick~=nil)then
		blackoutkick:SelfDispel()
	elseif(self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_Serenity)~=nil)then
		return
	else
		TRAININGGROUNDS_Spell.deductResourceCost(self)
	end
end

--function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick:ApplyExecutedSpellSideEffects(executespelltick)
	--TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick:OnImpact(executespelltick)
	TRAININGGROUNDS_Spell.OnImpact(self,executespelltick)
	
	

	--TODO: apply on impact
	self.combat:SetSCKTarget(self.target,executespelltick+15000)

	-- self.istornado=true
	-- self.button.frame:Hide()
	-- self.combat.tornadokick.button.frame:Show()
	-- --print("TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick:ApplyExecutedSpellSideEffects")
	
	local ttp=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TransferThePower.new()
	ttp:setup(self.combat,self.impacttime)
end


function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_BlackoutKick:IncrementSpellUseCount()
	--print("IncrementSpellUseCost")
	local blackoutkick=self.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_ComboBreakerBlackoutKick)
	if(blackoutkick~=nil)then
		self.combat.fakecombobreakerblackoutkick.usecount=self.combat.fakecombobreakerblackoutkick.usecount+1
		if(self.combat.fakecombobreakerblackoutkick.usecounttextbox~=nil)then
			self.combat.fakecombobreakerblackoutkick.usecounttextbox.frame.fontstring:SetText(self.combat.fakecombobreakerblackoutkick.shortspellname..": "..self.combat.fakecombobreakerblackoutkick.usecount)
		end
	else
		self.usecount=self.usecount+1
	end
end