TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiWave = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiWave:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Chi Wave"
	self.shortspellname="CW"
	
	--self.animationsequence=54
	--self.animationlength=1000
		
	self.animationname="FinishUndirectedSpellcast"
	
	self.defaultcooldown=15000
	
	-- self.defaultcooldown=0	--!!!
	-- self.casted=true
	-- self.casttime=3000
	-- self.castablewhilemoving=false
	
	
	-- range is "40 yards", or whatever feels right
	self.range=800	-- at the moment, "800" feels right
	
	self.procscombostrikes=true
	
	--TODO: bounce properly 
	--self.impacttime=250
	self.impacttime=500
	--(50 x4)
	self.damage=50
	
	self.icon="Interface\\Icons\\ability_monk_chiwave"
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_ChiWave:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	
	--TODO: replace snapshot_target with self.target
		-- can probably replace snapshot_damage too
	local snapshot_damage=self.damage
	--local snapshot_target=self.combat.target
	local snapshot_target=self.target
	
	if(self.combat.target~=nil) then				
		-- -- impacttime*1 happens by default
		-- self.combat:QueueImpact(executespelltick+self.impacttime*1, 
							-- function(tick)self.combat:ApplyDamageToEnemy(snapshot_damage,snapshot_target)end)
		self.combat:QueueImpact(executespelltick+self.impacttime*2, 
							function(tick)self.combat:ApplyDamageToEnemy(snapshot_damage,snapshot_target)end)
		self.combat:QueueImpact(executespelltick+self.impacttime*3, 
							function(tick)self.combat:ApplyDamageToEnemy(snapshot_damage,snapshot_target)end)
		self.combat:QueueImpact(executespelltick+self.impacttime*4, 
							function(tick)self.combat:ApplyDamageToEnemy(snapshot_damage,snapshot_target)end)							
	end
end