TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Spell)

--TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.TEBDURATION=15000
TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.TEBDURATION=18000
--TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.TEBDURATION=90000
TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.SEFMULTIPLIER=0.45

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew:setCustomSpellInfo(combat)
	TRAININGGROUNDS_Spell.setCustomSpellInfo(self,combat)
	
	self.spellname="Storm, Earth, and Fire"
	self.shortspellname="SEF"
	
	--self.animationsequence=61
	--self.animationlength=3000
	--self.animationname="EatWhileStanding"
	
	--self.usesgcd=false
	self.usesgcd=true
	
	
	--self.defaultcooldown=5000
	self.defaultcooldown=TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.TEBDURATION
	self.defaultrecharge=90000
	self.maxcharges=2	
	self.onlyshowrechargenevercooldown=true
	
	self.requirestarget=false
	
	--self.icon="Interface\\Icons\\ability_monk_tigereyebrandy"
	self.icon="Interface\\Icons\\spell_nature_giftofthewild"
	
	self.sefs={}	
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew:ApplyExecutedSpellSideEffects(executespelltick)
	TRAININGGROUNDS_Spell.ApplyExecutedSpellSideEffects(self,combat)
	-- local buff
	-- buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_VisualMainhandBrew.new()
	-- buff:setup(self.combat,executespelltick)	
	-- buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TigereyeBrew.new()
	-- buff:setup(self.combat,executespelltick)
	
	local buff
	buff=TRAININGGROUNDS_Buff_W7_WindwalkerMonk_StormEarthAndFire.new()
	buff:setup(self.combat,executespelltick)
	
	for i=1,2,1 do
		local sef=TRAININGGROUNDS_Pet_SEF.new()
		sef.sefindex=i
		sef.owner=self.combat.character
		sef:setup(self.combat.character.environment)
		sef.spell=self		
		tinsert(sef.owner.combat.pets,sef)
		sef.x,sef.y=self.combat.character.x,self.combat.character.y
		sef.expirytime=executespelltick+TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew.TEBDURATION
		self.sefs[i]=sef
	end
			
end

function TRAININGGROUNDS_Spell_W7_WindwalkerMonk_TigereyeBrew:executeDespiteCooldown(executespelltick)	
	if(self.sefs[1]~=nil and self.sefs[2]~=nil)then
		--TODO: edge case where sefs1-2 have different focustargets

		local newtarget=self.combat.target
		-- if(newtarget==nil or self.sefs[1].focustarget==newtarget)then	
			-- self.combat.character.environment.game:createSpellTextbox("(SEF: Split)")
			-- for i=1,2,1 do
				-- self.sefs[i].focustarget=nil
				-- self.sefs[i].combat:ChangeTarget(nil)
			-- end
		-- else
			-- if(self.sefs[1].focustarget~=newtarget)then
				-- self.combat.character.environment.game:createSpellTextbox("(SEF: Focus)")
				-- for i=1,2,1 do
					-- self.sefs[i].focustarget=newtarget
					-- self.sefs[i].combat:ChangeTarget(newtarget)
				-- end		
			-- end
		-- end
		
		if(newtarget~=nil and self.sefs[1].focustarget~=newtarget)then	
			self.combat.character.environment.game:createSpellTextbox("(SEF: Focus)")
			for i=1,2,1 do
				self.sefs[i].focustarget=newtarget
				self.sefs[i].combat:ChangeTarget(newtarget)
			end		
		end
		return true
	end
	return false
end