TRAININGGROUNDS_ArenaBorder = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_GameObject)


function TRAININGGROUNDS_ArenaBorder:SetCustomInfo()
	TRAININGGROUNDS_GameObject.SetCustomInfo(self)
	self.ysortable=false	
end

function TRAININGGROUNDS_ArenaBorder:SetFrame()


	--don't call super

	self.frame=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.frame.parent=self.environment.frame	
	self.frame:SetParent(self.frame.parent)
	self.frame:SetPoint("CENTER",self.frame.parent,"CENTER",0,0)
	--self.frame:SetFrameLevel(self.environment.ysortframelevel-2)	--TODO:
	self.frame:SetFrameLevel(1)
	self.frame.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\bigblankcircle.tga")
	--RGBA
	self.frame.texture:SetGradientAlpha("VERTICAL",1,1,1,1,1,1,1,1)
	self.frame:Show()
	self.frame.texture:Show()	
	
	self.arenafill=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.arenafill.parent=self.frame	
	self.arenafill:SetParent(self.frame)
	self.arenafill:SetPoint("CENTER",self.frame,"CENTER",0,0)
	--self.arenafill:SetFrameLevel(self.environment.ysortframelevel-1)	--TODO:
	self.frame:SetFrameLevel(2)
	self.arenafill.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\bigblankcircle.tga")
	--RGBA
	self.arenafill.texture:SetGradientAlpha("VERTICAL",0.0625,0.0625,0.0625,1,0.0625,0.0625,0.0625,1)
	self.arenafill:Show()
	self.arenafill.texture:Show()	
	
	--print("Arenaborder.lua: arena frame on frame level "..self.environment.ysortframelevel-2)
end

function TRAININGGROUNDS_ArenaBorder:SetFrameSize()
	local camera=self.environment.camera	
	self.frame:SetWidth((self.environment.arenaradius*2+self.environment.arenaborderwidth*2)*camera.zoom)
	self.frame:SetHeight((self.environment.camera.ystretch*(self.environment.arenaradius*2+self.environment.arenaborderwidth*2))*camera.zoom)
	self.arenafill:SetWidth((self.environment.arenaradius*2)*camera.zoom)
	self.arenafill:SetHeight((self.environment.camera.ystretch*(self.environment.arenaradius*2))*camera.zoom)	

end

function TRAININGGROUNDS_ArenaBorder:SetDefaultFrameLevel()
	self.frame:SetFrameLevel(1)
	self.arenafill:SetFrameLevel(2)
end


function TRAININGGROUNDS_ArenaBorder:Cleanup()
	self.arenafill:Cleanup()
	TRAININGGROUNDS_GameObject.Cleanup(self)
end
