TRAININGGROUNDS_Environment_World = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Environment)

function TRAININGGROUNDS_Environment_World:setup(game,gameframe)
	TRAININGGROUNDS_Environment.setup(self,game,gameframe)
	
	self.arenaradius=1000
	self.arenaborderwidth=20
	
	self.camera.ysort=true
	self:ResetCamera()
	self.camera.objectanchor="CENTER"
	
	local view=1				------------- <-- camera angle, default 1
	
	if(view==0)then
		-- side view
		--self.camera.ystretch=0.01
		self.camera.ystretch=0.1
		--self.camera.ystretch=0.1
		--self.camera.ystretch=1
		self.camera.zstretch=1
		self.camera.modelangle=0
		--self.camera.permoffsety=-125/self.camera.ystretch
	elseif(view==1)then
		-- three quarters view (default for gameplay)
		self.camera.ystretch=0.75	-- TODO: should this be 1/sqrt(2)?
		self.camera.zstretch=0.75
		self.camera.modelangle=-math.pi/4
	elseif(view==2)then
		-- overhead view
		self.camera.ystretch=1
		self.camera.zstretch=0
		self.camera.modelangle=-math.pi*(7.0/16)
	end
	-- do not exceed -math.pi*(7.0/16).  at some point, SetFacing will flip backwards to try to keep the model "upright"
	--self.camera.modelangle=-math.pi*(7.0/16)
	
	

	

	-- self.player=TRAININGGROUNDS_PlayerCharacter.new()
	-- --self.player=TRAININGGROUNDS_WoWCharacter.new()
	-- self.player:setup(self)
	-- self.player.x=-55
	-- self.player.y=-115
	-- --self.player.x=0;self.player.y=0
	
	-- self.camera.camerafocus=self.player
	
	-- -- self.npc=TRAININGGROUNDS_FakePlayerCharacter.new()
	-- -- self.npc:setup(self)
	-- -- self.npc.x=100
	-- -- self.npc.y=0

	
	-- self.npc=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_IllusionaryConqueror.new()
	-- self.npc:setup(self)
	-- self.npc.x=55
	-- self.npc.y=-30
	-- --local facing=math.atan2((self.player.y-self.npc.y)/self.camera.ystretch,self.player.x-self.npc.x)+math.pi/2
	-- local facing=math.atan2((self.player.y-self.npc.y),self.player.x-self.npc.x)+math.pi/2	
	-- self.npc.currentfacing=facing	
	-- self.npc.modelframe:SetFacing(facing)
	
	-- local facing=math.atan2((self.player.y-self.npc.y),self.player.x-self.npc.x)+math.pi/2
	-- self.player.currentfacing=facing+math.pi
	-- self.player.modelframe:SetFacing(facing+math.pi)
	
	-- -- -- "proving grounds enemies"
	-- -- for i=1,1,1 do
		-- -- --self.npc=TRAININGGROUNDS_WoWCharacter.new()
		-- -- self.npc=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionarySlayer.new()
		-- -- self.npc:setup(self)
		-- -- self.npc.x=102
		-- -- self.npc.y=-200

		-- -- self.npc=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_LargeIllusionarySlayer.new()
		-- -- self.npc:setup(self)
		-- -- self.npc.x=302
		-- -- self.npc.y=-200

		-- -- self.npc=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_HugeIllusionarySlayer.new()
		-- -- self.npc:setup(self)
		-- -- self.npc.x=552
		-- -- self.npc.y=-200
		
		-- -- self.npc=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_SmallIllusionaryVarmint.new()
		-- -- self.npc:setup(self)
		-- -- self.npc.x=-102
		-- -- self.npc.y=400

		-- -- self.npc=TRAININGGROUNDS_Enemy_W7_ProvingGrounds_LargeIllusionaryVarmint.new()
		-- -- self.npc:setup(self)
		-- -- self.npc.x=-252
		-- -- self.npc.y=400		
	-- -- end
	
	
	
	
	
	
	-- -- --TODO: convert to nonysortable gameobject
	-- -- self.arenaborderframe=TRAININGGROUNDS_ReusableFrames.getFrame()
	-- -- self.arenaborderframe:SetWidth(self.arenaradius*2+self.arenaborderwidth*2)
	-- -- self.arenaborderframe:SetHeight(self.camera.ystretch*(self.arenaradius*2+self.arenaborderwidth*2))
	-- -- self.arenaborderframe.parent=self.frame		
	-- -- self.arenaborderframe:SetParent(self.arenaborderframe.parent)
	-- -- self.arenaborderframe:SetPoint("CENTER",self.arenaborderframe.parent,"CENTER",0,0)
	-- -- self.arenaborderframe:SetFrameLevel(1)	--TODO:
	-- -- self.arenaborderframe.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\bigblankcircle.tga")
	-- -- --RGBA
	-- -- self.arenaborderframe.texture:SetGradientAlpha("VERTICAL",1,1,1,1,1,1,1,1)
	-- -- self.arenaborderframe:Show()
	-- -- self.arenaborderframe.texture:Show()	
	-- -- self.arenaborder=TRAININGGROUNDS_ReusableFrames.getFrame()
	-- -- self.arenaborder:SetWidth(self.arenaradius*2)
	-- -- self.arenaborder:SetHeight(self.camera.ystretch*(self.arenaradius*2))
	-- -- self.arenaborder.parent=self.frame	
	-- -- self.arenaborder:SetParent(self.arenaborder.parent)
	-- -- self.arenaborder:SetPoint("CENTER",self.arenaborder.parent,"CENTER",0,0)
	-- -- self.arenaborderframe:SetFrameLevel(2)	--TODO:
	-- -- self.arenaborder.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\bigblankcircle.tga")
	-- -- --RGBA
	-- -- self.arenaborder.texture:SetGradientAlpha("VERTICAL",0.0625,0.0625,0.0625,1,0.0625,0.0625,0.0625,1)
	-- -- self.arenaborder:Show()
	-- -- self.arenaborder.texture:Show()	
	
	
	
end

--TODO: do we need this function?
function TRAININGGROUNDS_Environment_World:ResetCamera()
	self.camera.targetzoom=1.5
	self.camera.zoom=self.camera.targetzoom
	--!!!
	self.camera.zoomchanged=true
end

function TRAININGGROUNDS_Environment_World:step(elapsed)
	TRAININGGROUNDS_Environment.step(self,elapsed)
	
	for i=1,#self.gameobjects,1 do
		local obj=self.gameobjects[i]
		if(obj.cangooob~=true)then
			local radiussquared=obj.x*obj.x+obj.y*obj.y
			if(radiussquared>self.arenaradius*self.arenaradius)then
				local vector=math.sqrt(radiussquared)
				obj.x=obj.x/vector*self.arenaradius
				obj.y=obj.y/vector*self.arenaradius
			end
		end
	end
	
	local zoomchange=0
	if(self.game.keys.home.current or self.game.keys.pgup.current)then
		zoomchange=zoomchange+1
	end
	if(self.game.keys.endkey.current or self.game.keys.pgdn.current)then
		zoomchange=zoomchange-1
	end	
	local ZOOMSPEED=0.5
	self.camera:AdjustZoomViaScrollWheel(zoomchange*ZOOMSPEED)
	
	
	--TODO: move player movement to PlayerCharacter:step
	
	local obj=nil
	
	local movevectorxx=0
	local movevectoryy=0
	local mousemove=false
	local mousemovevectorxx=0
	local mousemovevectoryy=0
	local keyboardmove=false
	local keyboardmovevectorxx=0
	local keyboardmovevectoryy=0

	if(self.game.keys.up.current) then
		keyboardmovevectoryy=keyboardmovevectoryy+1
	end
	if(self.game.keys.down.current) then
		keyboardmovevectoryy=keyboardmovevectoryy-1
	end			
	if(self.game.keys.left.current) then
		keyboardmovevectorxx=keyboardmovevectorxx-1
	end
	if(self.game.keys.right.current) then
		keyboardmovevectorxx=keyboardmovevectorxx+1
	end		
	if(keyboardmovevectorxx~=0 or keyboardmovevectoryy~=0) then		
		keyboardmove=true
	end
	--even though we cap final movevector at 1, cap the keyboardmove vector now because it might be competing with mousemove
	if(keyboardmovevectorxx~=0 and keyboardmovevectoryy~=0) then		
		keyboardmovevectorxx=keyboardmovevectorxx*1/math.sqrt(2)
		keyboardmovevectoryy=keyboardmovevectoryy*1/math.sqrt(2)
	end
	

	
	--TODO: while casting, either require mouse to be held for a second, or double-clicked
	-- (allow change targets while casting without moving and interrupting cast)
	-- (alternately, don't move if player clicked on a target, D2-ranged-style)
	
	local mousedestinationx=nil
	local mousedestinationy=nil
	local mousevectorlength=nil
	local mousedestinationdistance=nil
	
	local uiscale,globalx,globaly=UIParent:GetEffectiveScale(),GetCursorPosition()		
	-- must divide by uiscale AND gamescale		
	local gamescale=self.game.frame:GetScale()
	
	
	globalx=globalx/uiscale/gamescale
	globaly=globaly/uiscale/gamescale
	local left,bottom,width,height=self.frame:GetRect()
	--TODO: revise math and logic
	-- -- this block works for fixed camera with any zoom
	-- local localx=globalx-left
	-- local localy=globaly-bottom			
	-- local offsetx,offsety=self.camera:GetScrollOffset()
	-- offsetx=offsetx+TRAININGGROUNDS_Game.SCREENWIDTH/2
	-- offsety=offsety+(TRAININGGROUNDS_Game.SCREENHEIGHT/2)
	-- localx=localx-offsetx
	-- localy=localy-offsety
	-- local camerax,cameray=localx,localy
	-- camerax=camerax*(1/self.camera.zoom)
	-- cameray=cameray*(1/self.camera.zoom)
	-- cameray=cameray*(1/self.camera.ystretch)

	-- -- this block works for moving camera with fixed zoom
	-- local localx=globalx-left
	-- local localy=globaly-bottom			
	-- local offsetx,offsety=self.camera:GetScrollOffset()	
	-- offsety=offsety*self.camera.ystretch
	-- offsetx=offsetx+TRAININGGROUNDS_Game.SCREENWIDTH/2
	-- offsety=offsety+(TRAININGGROUNDS_Game.SCREENHEIGHT/2)
	-- localx=localx-offsetx
	-- localy=localy-offsety
	-- local camerax,cameray=localx,localy
	-- camerax=camerax*(1/self.camera.zoom)
	-- cameray=cameray*(1/self.camera.zoom)
	-- cameray=cameray*(1/self.camera.ystretch)
	
	local localx=globalx-left
	local localy=globaly-bottom			
	--local offsetx,offsety=self.camera:GetScrollOffset()	
	local offsetx,offsety=0,0
	offsety=offsety*self.camera.ystretch
	offsetx=offsetx*self.camera.zoom
	offsety=offsety*self.camera.zoom
	offsetx=offsetx+TRAININGGROUNDS_Game.SCREENWIDTH/2
	offsety=offsety+(TRAININGGROUNDS_Game.SCREENHEIGHT/2)
	localx=localx-offsetx
	localy=localy-offsety
	

	
	------------- Onclick target change ------------
		-- TODO: one function to check for mouse detection
		-- 		-- don't repeat code from Environment.lua
	if(self.game.keys.mouseL.pressed) then
		--print("Environment_World.lua "..camerax..","..cameray)
		for i=1,#self.gameobjects,1 do
			local obj=self.gameobjects[i]
			if(obj.clickable==true)then
				-- since we're operating in camera coordinates, divide by ystretch
				-- TODO: overridable GetClickareaRect
				local adjustedcamerax,adjustedcameray=localx,localy
				local modelratio=1
				if(obj.modelinfo~=nil)then					
					modelratio=obj.modelinfo.gameplayscaleratio*obj.extrascale
					--print("New modelratio is "..modelratio)
				end
				local adjustedzoom=self.camera.zoom
				adjustedcamerax=adjustedcamerax*(1/adjustedzoom)
				adjustedcameray=adjustedcameray*(1/adjustedzoom)
				adjustedcameray=adjustedcameray*(1/self.camera.ystretch)	
				
				local x1=obj.x+(obj.clickarea.x-obj.clickarea.width/2)*modelratio
				local x2=obj.x+(obj.clickarea.x+obj.clickarea.width/2)*modelratio
				local y1=obj.y+(obj.clickarea.y)/self.camera.ystretch*modelratio
				local y2=obj.y+(obj.clickarea.y+obj.clickarea.height)/self.camera.ystretch*modelratio
				
				if(adjustedcamerax>=x1)then
					if(adjustedcamerax<=x2)then						
						if(adjustedcameray>=y1)then
							if(adjustedcameray<=y2)then	
								--print("Environment_World.lua clicking on "..tostring(obj))																
								self.player.combat:ChangeTarget(obj)								
								self.player.combat:OnClickTarget(obj)
							end
						end
					end
				end
			end
		end
	end
	
	local camerax,cameray=localx,localy
	camerax=camerax*(1/self.camera.zoom)
	cameray=cameray*(1/self.camera.zoom)
	cameray=cameray*(1/self.camera.ystretch)	
	
	
	if(self.game.keys.mouseL.current==true and _TRAININGGROUNDS.debug_visibleclicks==true) then	
		--print("Environment_World.lua visibleclicks "..camerax..","..cameray)
		local textbox=TRAININGGROUNDS_TemporaryTextField.new()
		textbox:setup(self)
		--textbox.frame.fontstring:SetJustifyH("LEFT")
		textbox.frame.fontstring:SetText("X")
		textbox.x=camerax
		textbox.y=cameray--/self.camera.ystretch
		--textbox.x=0;textbox.y=0	--!!!
		--textbox.x=-320;textbox.y=-240/self.camera.ystretch	--!!!
		textbox.frame:SetWidth(20);textbox.frame:SetHeight(20)
		textbox.alignment="CENTER"
		textbox.frame:ClearAllPoints()
		textbox:draw()
		textbox.frame:Show()
		textbox.frame.texture:Show()

		textbox.expirytime=self.currenttime+2000			
	end
	if(self.player~=nil)then
		if(self.game.keys.mouseL.current==true and self.game.keys.mouseR.current==true) then
			mousemove=true				
			mousedestinationx=camerax
			mousedestinationy=cameray
			mousemovevectorxx=mousedestinationx-self.player.x
			mousemovevectoryy=mousedestinationy-self.player.y
			--print("Game.lua movevector "..movevectorxx..","..movevectoryy)
			mousevectorlength=math.sqrt(mousemovevectorxx*mousemovevectorxx+mousemovevectoryy*mousemovevectoryy)			
			mousedestinationdistance=mousevectorlength
			if(mousevectorlength>1)then
				mousemovevectorxx=mousemovevectorxx/mousevectorlength
				mousemovevectoryy=mousemovevectoryy/mousevectorlength
			end			
		end	
	end

	-- don't average keyboard+mouse, but do add them and then cap the result at 1
	movevectorxx=mousemovevectorxx+keyboardmovevectorxx
	movevectoryy=mousemovevectoryy+keyboardmovevectoryy
	local vectorlength=math.sqrt(movevectorxx*movevectorxx+movevectoryy*movevectoryy)
	if(vectorlength>1)then
		movevectorxx=movevectorxx/vectorlength
		movevectoryy=movevectoryy/vectorlength
	end	
	
	-- if we're using mouse and character is already very close to destination, don't move at all
	-- TODO: but do still turn around
	-- TODO: and maybe walk, if we're only sort of close
	if(mousemove==true) then
		if(mousevectorlength~=nil) then
			--TODO: use camerazoom instead of modelscale
			if(mousevectorlength<self.camera.zoom*4) then
				movevectorxx=0
				movevectoryy=0
			end
		end
	end

	
	if(self.player~=nil)then
		if(self.player.combat.movementqueuedspell~=nil)then
			if(self.player.combat.movementqueuedspell:RangeIsOkay(self.player,self.player.combat.target).success~=true)then
				local targetx,targety=self.player.combat.target.x,self.player.combat.target.y
				local autodestinationx=targetx
				local autodestinationy=targety
				local automovevectorxx=autodestinationx-self.player.x
				local automovevectoryy=autodestinationy-self.player.y
								
				local autovectorlength=math.sqrt(automovevectorxx*automovevectorxx+automovevectoryy*automovevectoryy)			
				--local autodestinationdistance=autovectorlength
				if(autovectorlength>1)then
					automovevectorxx=automovevectorxx/autovectorlength
					automovevectoryy=automovevectoryy/autovectorlength
				end	
				
				-- if movevector is compatible with automovevector, add them and then cap the result at 1
				local compatible=false
				-- "compatible" if player input vector is 0 
				if(movevectorxx==0 and movevectoryy==0)then 
					compatible=true
				-- -- optional: "compatible" within 90 degrees of autovector
				-- else
					-- local playerangle=math.atan2(movevectoryy,movevectorxx)
					-- local autoangle=math.atan2(automovevectoryy,automovevectorxx)
					-- local difference=math.abs(playerangle-autoangle)
					-- if(difference<=math.pi*.5 or difference>=math.pi*1.5)then
						-- compatible=true
					-- else
						-- compatible=false
					-- end
				end
				
				if(compatible==true)then
					movevectorxx=movevectorxx+automovevectorxx
					movevectoryy=movevectoryy+automovevectoryy
					local vectorlength=math.sqrt(movevectorxx*movevectorxx+movevectoryy*movevectoryy)
					if(vectorlength>1)then
						movevectorxx=movevectorxx/vectorlength
						movevectoryy=movevectoryy/vectorlength
					end
				else
					-- else cancel automove
					self.player.combat.movementqueuedspell=nil
				end
			end
		end
	end		

	
	
	--TODO: use player.walkmodifier
	--TODO: use walkmodifier 1.1 for windwalker players
	--local walkmodifier=1.5	
	local walkmodifier=1
	if(self.player~=nil)then
		local tl=self.player.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_W7_WindwalkerMonk_TigersLust)
		if(tl~=nil)then
			walkmodifier=1.7 --TL
			--Roll: 2.75 (handled in roll buff)
		end
	end
	
	local turnspeed=1
	if(self.game.keys.x.current) then
		walkmodifier=0.33
		turnspeed=0.33
	end
	

	--TODO: movespeed doesn't take modelscale into account
	local movevectorlength=math.sqrt(movevectorxx*movevectorxx+movevectoryy*movevectoryy)
	local movespeed=movevectorlength*walkmodifier
	
	
	if(self.player~=nil)then
		--TODO: use lockmovement/facingendtick instead?
		local tutorialintrobuff=self.player.combat:GetBuffIfExists(TRAININGGROUNDS_Buff_Tutorial_IntroPlayerSpawnSequence)
		if(tutorialintrobuff~=nil)then
			movevectorxx=0;movevectoryy=0;movespeed=0
			self.player:SetAdjustedFacing(0)
		end

	
		--TODO: some lines don't take movespeed into account	
		--self.player.x=self.player.x+movevectorxx*elapsed*TRAININGGROUNDS_Game.TEMP_MOVESPEED*walkmodifier*1;
		--self.player.y=self.player.y+movevectoryy*elapsed*TRAININGGROUNDS_Game.TEMP_MOVESPEED*walkmodifier*1;
		
		if(self.player.z<=0)then
			if(self.player.lockmovementendtick<=self.currenttime)then
				self.player.xspeed=movevectorxx*TRAININGGROUNDS_Game.TEMP_MOVESPEED*walkmodifier*1;
				self.player.yspeed=movevectoryy*TRAININGGROUNDS_Game.TEMP_MOVESPEED*walkmodifier*1;
				self.player.movespeed=movespeed
				self.player:SetAnimationThisFrame(self.currenttime)
			
				if(self.game.keys.space.pressed) then
					self.player:AttemptJump()
				end
			end
		end
	end

	
	if(self.player~=nil)then
		if(self.player.snapfacingtarget~=nil)then
			if(self.player.snapfacingtarget.dead==true)then
				self.player.snapfacingtarget=nil
			end	
		end
		
		if(self.player.snapfacingendtick>self.currenttime)then			
			if(self.player.snapfacingtarget~=nil)then				
				local target=self.player.snapfacingtarget
				local snapfacing=math.atan2(target.x-self.player.x,-(target.y-self.player.y))
				--local snapfacing=math.atan2((target.y-self.player.y)*self.camera.ystretch,target.x-self.player.x)
				--print("Snap facing to ",snapfacing)
				local SNAPTURNSPEED=1.5
				if(self.currenttime>=self.player.lockfacingendtick)then
					self.player:changeFacing(snapfacing,elapsed,SNAPTURNSPEED)
				end
			end
		else			
			if(movevectorxx~=0 or movevectoryy~=0) then
				-- normally atan2 is (y,x) but this is world of warcraft
				--TODO: we're still using atan2(y,x) in a few places -- fix it!
							-- and find out why it looks like it works anyway in those places, but not in other places
				--local movevectorfacing=math.atan2(movevectorxx,-movevectoryy*1/math.sqrt(2))	
				local movevectorfacing=math.atan2(movevectorxx,-movevectoryy)	
				if(self.currenttime>=self.player.lockfacingendtick)then
					--print(self.currenttime,self.player.lockfacingendtick,movevectorfacing)
					self.player:changeFacing(movevectorfacing,elapsed,turnspeed)
				end
			end
		end
	end
	
	-- --!!!
	-- --self.npc.movespeed=0
	-- --self.npc:SetAnimationThisFrame(self.currenttime)
	-- for i=1,#self.wowcharacters,1 do
		-- local ch=self.wowcharacters[i]
		-- if(ch~=self.player)then
			-- ch.movespeed=0
			
		-- end
	-- end
	
	
	
	
	--- end of movement -----------------------------------------------
	
	
	if(self.player~=nil)then
		if(self.player.combat.target~=nil)then
	
		end
	end
	
	if(self.player~=nil)then
		self.player.combat:draw(self.currenttime)
	end
end