TRAININGGROUNDS_MenuButton = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_GameObject)


function TRAININGGROUNDS_MenuButton:SetFrame()
	--don't call super
--print("TRAININGGROUNDS_MenuButton:SetFrame()")
	self.frame=TRAININGGROUNDS_ReusableButtonFrames.getFrame()
	--TODO: set frame level	
	self.frame:SetWidth(400);self.frame:SetHeight(50)
		
	self.textframe=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.textframe.tag="MenuButton textframe"
	self.textframe:SetParent(self.frame)
	self.textframe:SetAllPoints(self.frame)
	
end

function TRAININGGROUNDS_MenuButton:SetAppearance()
--print("TRAININGGROUNDS_MenuButton:SetAppearance()")
	self.frame:Show()
	--!!!
	--self.frame.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\placeholder_logo.tga")
	--TODO: use Button:SetHighlightTexture instead
	self.frame.texture:Show()	
	
	--self.frame.texture:SetTexture(1,1,1,1)
	self.alignment="TOPLEFT"
	
	self.border=TRAININGGROUNDS_BorderGraphic.new()
	self.border:setup(self.frame)
	
end

function TRAININGGROUNDS_MenuButton:SetClickability()
	-- override. don't call super when overriding
	self.clickable=true	
	self.clickarea={}
	self.clickarea.x=0; self.clickarea.y=0; self.clickarea.width=self.frame:GetWidth(); self.clickarea.height=self.frame:GetHeight()
end

function TRAININGGROUNDS_MenuButton:Resize(wid,hgt)
	self.frame:SetWidth(wid)
	self.frame:SetHeight(hgt)
	self.border:Redraw(self.frame)
	self:SetClickability()
end

function TRAININGGROUNDS_MenuButton:SetText(text)	
	self.textframe.fontstring:SetJustifyH("CENTER")
	self.textframe.fontstring:SetText(text)
	self.textframe:Show()
	self.textframe.fontstring:Show()
end

function TRAININGGROUNDS_MenuButton:SetCurrentAlpha(alpha)
	self.currentalpha=alpha
	self.frame:SetAlpha(alpha)
end

function TRAININGGROUNDS_MenuButton:step(elapsed)
	TRAININGGROUNDS_GameObject.step(self,elapsed)

	ActionButton_HideOverlayGlow(self.frame)
	
	--TODO: apply this to all GameObjects?	
	if(self.currentalpha==nil)then
		self.currentalpha=self.frame:GetAlpha()
	end
	if(self.targetalpha==nil)then
		self.targetalpha=self.currentalpha
	end
	if(self.alphachangerate==nil)then
		self.alphachangerate=3
	end	
	if(self.targetalpha>self.currentalpha)then
		self.currentalpha=self.currentalpha+self.alphachangerate*elapsed
		if(self.currentalpha>self.targetalpha)then self.currentalpha=self.targetalpha end
		self.frame:SetAlpha(self.currentalpha)
	elseif(self.targetalpha<self.currentalpha)then
		self.currentalpha=self.currentalpha-self.alphachangerate*elapsed
		if(self.currentalpha<self.targetalpha)then self.currentalpha=self.targetalpha end
		self.frame:SetAlpha(self.currentalpha)
	end	
end

function TRAININGGROUNDS_MenuButton:draw()
	--TODO: replace with button:sethighlighttexture
	if(self.ismouseovered==true)then
		self.frame.texture:SetTexture(1,1,1,.25)
	else
		self.frame.texture:SetTexture(1,1,1,0)
	end
		
	TRAININGGROUNDS_GameObject.draw(self)
end


function TRAININGGROUNDS_MenuButton:Cleanup()
	TRAININGGROUNDS_GameObject.Cleanup(self)
	-- Button frame will be removed in GameObject.Cleanup
	
	-- but we still need to remove textframe from here
	self.textframe:Cleanup()
	
	self.border:Cleanup()	
	
end

