TRAININGGROUNDS_StylizedScrollframeIntroObject = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_GameObject)

function TRAININGGROUNDS_StylizedScrollframeIntroObject:SetFrame()
	self.frame=TRAININGGROUNDS_ReusableFrames.getFrame()
	self.scrollframes={}
	self.slices=9
	self.slicewidth=8		
	for i=1,self.slices,1 do
		--local f=TRAININGGROUNDS_ReusableScrollFrames.getFrame()
		local f=TRAININGGROUNDS_ReusableScrollFrames.getFrame()
		self.scrollframes[i]=f				--	<--- POSSIBLE CRASH ERROR
	end
	self.fulltitleframe=TRAININGGROUNDS_ReusableFrames.getFrame()
	
	self.scrollprogress=0
	self.defaultscrollticktimer=0.016
	--self.defaultscrollticktimer=0.032
	--self.defaultscrollticktimer=0.064
	--self.defaultscrollticktimer=0.1
	self.scrollticktimer=self.defaultscrollticktimer
	

	
end

function TRAININGGROUNDS_StylizedScrollframeIntroObject:SetAppearance()
	self.frame:SetWidth(16)
	self.frame:SetHeight(16)
	self.frame.parent=self.environment.frame
	self.frame:SetParent(self.frame.parent)
	self.frame:SetPoint("CENTER",self.frame.parent,"CENTER",0,0)
	self.frame:Show()
	for i=1,#self.scrollframes,1 do
		local f=self.scrollframes[i]
		--f.scrollframe:SetWidth(512)
		
		-- TODO: add self.scrollprogress to sethorizontalscroll and setpoint
		f.scrollframe:SetWidth(self.slicewidth)
		f.scrollframe:SetHorizontalScroll(i*self.slicewidth)
		f.scrollframe:SetHeight(512*(45/512.0))		
		f.scrollframe:SetFrameLevel(255)
		f.scrollframe.parent=self.frame
		f.scrollframe:SetParent(f.scrollframe.parent)
		f.scrollframe:SetPoint("CENTER",f.scrollframe.parent,"CENTER",i*self.slicewidth,0)	
		f.scrollframe:Show()
		local a=1-math.abs(self.slices/2+.5-i)/(self.slices/2+.5)
		a=a*a
		f.scrollframe:SetAlpha(a)
		f:SetWidth(512)
		f:SetHeight(512*(45/512.0))
		-- f.parent=self.frame
		-- f:SetParent(f.parent)
		f:SetPoint("CENTER",0,"CENTER",0,0)
		-- f:SetFrameLevel(255)
		-- --self.frame:SetAlpha(0.5)
		f:Show()	

		f.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\placeholder_logo.tga")
		-- --left, right, top, bottom
		f.texture:SetTexCoord(0,1,0,(45/512.0))	
		f.texture:Show()
		-- --print("TRAININGGROUNDS_TitleLogo:SetAppearance() "..tostring(self.frame))	
		
		-- if(i==1)then
			-- TRAININGGROUNDS_FrameVisibilityCheck(f.scrollframe)
		-- end
	end
	self.fulltitleframe:SetWidth(self.slicewidth)
	self.fulltitleframe:SetHeight(512*(45/512.0))		
	self.fulltitleframe:SetFrameLevel(255)
	self.fulltitleframe.parent=self.frame
	self.fulltitleframe:SetParent(self.fulltitleframe.parent)
	self.fulltitleframe:SetPoint("CENTER",self.fulltitleframe.parent,"CENTER",0,0)		
	self.fulltitleframe.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\placeholder_logo.tga")
	-- --left, right, top, bottom
	self.fulltitleframe.texture:SetTexCoord(0,1,0,(45/512.0))	
	self.fulltitleframe.texture:Show()	
end

function TRAININGGROUNDS_StylizedScrollframeIntroObject:step(elapsed)
	self.scrollticktimer=self.scrollticktimer-elapsed
	while(self.scrollticktimer<0)do
		self.scrollticktimer=self.scrollticktimer+self.defaultscrollticktimer
		self.scrollprogress=self.scrollprogress+self.slicewidth
		if(self.scrollticktimer<-1)then
			self.scrollticktimer=-1
		end
	end
		
	--print(self.scrollprogress)
	for i=1,#self.scrollframes,1 do
		local f=self.scrollframes[i]
		f.scrollframe:SetHorizontalScroll(i*self.slicewidth+self.scrollprogress)
	end
	--TODO: better math
	self.x=75+self.scrollprogress
	
	if(self.scrollprogress>600) then self.scrollprogress=-16*12 end	--!!!
	-- if(self.scrollprogress>600) then
		-- self.x=0
		-- for i=1,#self.scrollframes,1 do
			-- self.scrollframes[i]:Hide()
		-- end
		-- self.fulltitleframe:Show()
	-- end
end

function TRAININGGROUNDS_StylizedScrollframeIntroObject:Cleanup()
	TRAININGGROUNDS_GameObject.Cleanup(self)
	
	for i=1,#self.scrollframes,1 do
		TRAININGGROUNDS_ReusableScrollFrames.removeFrame(self.scrollframes[i])		
	end
	TRAININGGROUNDS_ReusableFrames.removeFrame(self.fulltitleframe)
	
end