TRAININGGROUNDS_Enemy_Tutorial_Critter = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Enemy)

function TRAININGGROUNDS_Enemy_Tutorial_Critter:SetCombat()
	self.combat=TRAININGGROUNDS_CombatModule.new()
	self.combat:setup(self)
	self.combat:SetMaximumAndCurrentHP(TRAININGGROUNDS_CombatModule_W7_WindwalkerMonk.PLAYERHP) -- 6.2 PTR	
	
	local buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeIn.new()
	buff:setup(self.combat,self.environment.currenttime);	self.modelframe:SetAlpha(0)
end


function TRAININGGROUNDS_Enemy_Tutorial_Critter:SetModelSpecificInfo()
	-- Rabbit
	self.modelframe:SetDisplayInfo(328)
	self.modelinfo.sideviewoffsetY=29
	self.modelinfo.sideviewclickheight=60
	self.modelinfo.topviewoffsetY=20
	self.modelinfo.clickwidth=100
	self.modelinfo.offsetX=0
	self.modelinfo.gameplayscaleratio=1	
end

function TRAININGGROUNDS_Enemy_Tutorial_Critter:DramaticCritterDefeat(tick,player)
	--this is a "delayed impact" function, so "player" might not necessarily still exist in the level
	--TODO: verify the above statement is correct...

	--this should disable all the tutorial critter AI...
	self.airadius=nil
	
	
	local distance=math.sqrt((self.x-player.x)*(self.x-player.x)+(self.y-player.y)*(self.y-player.y))
	self.xspeed=(self.x-player.x)/distance*500
	self.yspeed=(self.y-player.y)/distance*500
	--print(self.xspeed,self.yspeed)

	--player.crittercount is set by scenariocontroller
	player.crittercount=player.crittercount-1
	
	
	self.zspeed=1000
	
	local buff
	buff=TRAININGGROUNDS_Buff_Tutorial_VisualFadeOut.new()
	--print(tick,player)
	buff:setup(self.combat,tick)
	buff.duration=1000
	
	self.expirytime=self.environment.currenttime+buff.duration
	self.cangooob=true

	--self.deadingame=true
	--if(self.combat.hp.value<=1)then	
		self:DieInGame(tick)
	--end	
	

	-- if(player.crittercount>0)then
		-- local message
		-- if(player.crittercount>1)then
			-- message=" |cFFFFFF00"..player.crittercount.."|cFFFFFFFF critters remaining "
		-- else
			-- message=" |cFFFFFF001|cFFFFFFFF critter remaining "
		-- end		
		-- local environment=self.environment
		-- local tm=TRAININGGROUNDS_TypewriterMessage.new()
		-- tm:setup(_TRAININGGROUNDS.game.environment_ui)
		-- tm.frame:SetWidth(500);tm.frame:SetHeight(100)
		-- tm.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")	
		-- tm:SetMessageAndCenterInUI(message)
		-- tm.y=-150
		-- tm.targety=tm.y
		-- tm.postexpirytime=1000		
		-- -- if this is set to true, text will advance regardless of the status of any other text in the scenario
		-- -- TODO: possibly allow for more than one typewriter manager per scenario
		-- tm.dontlock=true
		-- -- activation is handled by the owner scenario
		-- tm.activated=true
	-- end
	
end