TRAININGGROUNDS_Enemy_Tutorial_Critter_Rat = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_Enemy_Tutorial_Critter)

function TRAININGGROUNDS_Enemy_Tutorial_Critter_Rat:SetModelSpecificInfo()
	-- Rat
	-- WARNING: topviewoffsetY is waaaay off in order to make 3/4 view look acceptable!
	-- Don't use this model in overhead view!
	self.modelframe:SetDisplayInfo(1141)
	self.modelinfo.sideviewoffsetY=235
	self.modelinfo.sideviewclickheight=90
	self.modelinfo.topviewoffsetY=80
	self.modelinfo.clickwidth=140	--  wider than it needs to be, for running animation (normally 100)
	self.modelinfo.offsetX=44
	--self.modelinfo.gameplayscaleratio=1
	self.modelinfo.gameplayscaleratio=.75

end

function TRAININGGROUNDS_Enemy_Tutorial_Critter_Rat:step(elapsed)
	-- not only is 3/4 view calculation awkward,
	-- but rats tend to jump outside their clickbox during idle animation
	-- so we have to keep them moving
	TRAININGGROUNDS_Enemy_Tutorial_Critter.step(self,elapsed)
	
	-- The tutorial rat is programmed to circle around clockwise or counterclockwise at a given radius
			-- (radius and minradius must be assigned by the function that creates the rat).

	if(self.airadius~=nil)then
		if(self.airadius>self.minairadius)then
			self.airadius=self.airadius-75*elapsed
			if(self.airadius<self.minairadius)then
				self.airadius=self.minairadius
			end
		end
	
		local angle=math.atan2(self.y,self.x)
		
		angle=angle+0.1
		local targetx,targety=self.airadius*math.cos(angle),self.airadius*math.sin(angle)
		local moveangle=math.atan2(targety-self.y,targetx-self.x)
		
		--TODO: don't directly set xspeed/yspeed
		--TODO: move to WoWCharacter
		local MOVESPEED=200
		self.xspeed=math.cos(moveangle)*MOVESPEED
		self.yspeed=math.sin(moveangle)*MOVESPEED
		--print(self.xspeed,self.yspeed)
		
		self.movevectorxx=self.xspeed
		self.movevectoryy=self.yspeed
		self.movespeed=math.sqrt((self.xspeed*self.xspeed)+(self.yspeed*self.yspeed))
		local turnspeed=1
		local movevectorfacing=math.atan2(self.movevectorxx,-self.movevectoryy)	
		self:changeFacing(movevectorfacing,elapsed,turnspeed)
		
		--local currenttime=self.environment.currenttime
		--self:SetAnimationThisFrame(currenttime)
	end
	
end