TRAININGGROUNDS_FakePlayerCharacter_Shaman = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_Shaman:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)	
	self:ApplyHalfDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_Shaman:SetEquipmentInfo()
	self.equipment=TRAININGGROUNDS_Equipment.new()

	self.equipment:EquipItemToKnownSlot(119730,"ChestSlot")
	self.equipment:EquipItemToKnownSlot(119731,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(119732,"HandsSlot")
	self.equipment:EquipItemToKnownSlot(119733,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(119734,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(119735,"ShoulderSlot")
	self.equipment:EquipItemToKnownSlot(119736,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(119737,"WristSlot")	
	self.equipment:EquipItemToKnownSlot(119729,"MainHandSlot")	
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		self.equipment:EquipItemToKnownSlot(119729,"SecondaryHandSlot")	
	else
		self.equipment:EquipItemToKnownSlot(119725,"SecondaryHandSlot")	
	end
	self.equipment:EquipItemToKnownSlot(119708,"BackSlot")			
	
	-- for i=119730,119737,1 do
		-- self.equipment:TryItem(i)	
	-- end	
end

function TRAININGGROUNDS_FakePlayerCharacter_Shaman:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.OneHandBasicAttack,
		FakePlayerCharacterTitleAnimations.OneHandFancyAttack,
		FakePlayerCharacterTitleAnimations.DirectedSpellcast,
		
	}
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldFancyAttack)
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldSlashCombo)
	
	end
	return sequences
end