TRAININGGROUNDS_FakePlayerCharacter_Warrior = TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_FakePlayerCharacter)

function TRAININGGROUNDS_FakePlayerCharacter_Warrior:SetModelSpecificInfo()
	TRAININGGROUNDS_FakePlayerCharacter.SetModelSpecificInfo(self)
	self:ApplyDisabledEffect()
end

function TRAININGGROUNDS_FakePlayerCharacter_Warrior:SetEquipmentInfo()
	self.equipment=TRAININGGROUNDS_Equipment.new()
	
	self.equipment:EquipItemToKnownSlot(119772,"ChestSlot")
	self.equipment:EquipItemToKnownSlot(119773,"FeetSlot")
	self.equipment:EquipItemToKnownSlot(119774,"HandsSlot")
	self.equipment:EquipItemToKnownSlot(119775,"HeadSlot")
	self.equipment:EquipItemToKnownSlot(119776,"LegsSlot")
	self.equipment:EquipItemToKnownSlot(119777,"ShoulderSlot")
	self.equipment:EquipItemToKnownSlot(119778,"WaistSlot")
	self.equipment:EquipItemToKnownSlot(119779,"WristSlot")	
	-- -- this doesn't work unless the player is a Fury Warrior
	-- --TODO: find out if it's possible to accurately detect Titan's Grip w/o errors in spec or level
	if(false)then
		--self.equipment:EquipItemToKnownSlot(119771,"MainHandSlot")	
		--self.equipment:EquipItemToKnownSlot(119771,"SecondaryHandSlot")	
	elseif(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		self.equipment:EquipItemToKnownSlot(119781,"MainHandSlot")	
		self.equipment:EquipItemToKnownSlot(119781,"SecondaryHandSlot")	
	else	
		self.equipment:EquipItemToKnownSlot(119781,"MainHandSlot")	
		self.equipment:EquipItemToKnownSlot(119782,"SecondaryHandSlot")		
	end
	self.equipment:EquipItemToKnownSlot(119790,"BackSlot")
	
	-- for i=119772,119779,1 do
		-- self.equipment:TryItem(i)
	-- end	
end


function TRAININGGROUNDS_FakePlayerCharacter_Warrior:GetClassSpecificTitleScreenAnimationSequences()
	local sequences={
		FakePlayerCharacterTitleAnimations.OneHandFancyAttack,
		FakePlayerCharacterTitleAnimations.TankBlock,
		FakePlayerCharacterTitleAnimations.Bladestorm,
		FakePlayerCharacterTitleAnimations.Bladestorm,
	}
	if(TRAININGGROUNDS_PlayerCharacter.CanPlayerDW())then
		tinsert(sequences,FakePlayerCharacterTitleAnimations.DualWieldSlashCombo)		
	end
	return sequences
end